<?php
/**
* History:
*
* 1.0.0 - First version
* 1.1.0 - display informations of the TPL (file and template)
* 1.1.1 - add "*" for select all address IP 
* 1.2.0 - add CSS and JS for each modules
* 1.2.1 - optimization display
* 1.2.2 - optimization display (icon)
* 1.2.3 - open block H-M by hover or click
* 1.2.4 - add Module::isEnabled in overrides
* 1.2.5 - displaying the full url of the template 
* 1.2.6 - modification of CSS for display "+", this "+" will not be displayed with the themes that have not bootstrap) 
* 1.2.7 - option "front office only" and option "all the time" for display all datas without click
* 1.2.8 - small patch
* 1.3.0 - option display/hide informations with the touch ²
*
*  @author    Vincent MASSON <contact@coeos.pro>
*  @copyright Vincent MASSON <www.coeos.pro>
*  @license   http://www.coeos.pro/fr/content/3-conditions-generales-de-ventes
*/

if (!defined('_PS_VERSION_'))
	exit;

class WhatIsThisModule extends Module
{
	protected $error = false;

	public function __construct()
	{
		$this->name = 'whatisthismodule';
		$this->tab = 'administration';
		$this->version = '1.3.0';
		$this->author = 'www.coeos.pro';

		parent::__construct();

		$this->displayName = $this->l('What is this module ?');
		$this->description = $this->l('Displays informations about hooks, modules, CSS and JS files.').$this->overridesDisable();
		$this->confirmUninstall = $this->l('Are you sure you want to delete this module ?');
	}
	public function overridesDisable()
	{
		return ((int)Configuration::get('PS_DISABLE_OVERRIDES') == 1 && file_exists(_PS_MODULE_DIR_.$this->name.'/override/')) ? 
				$this->displayError($this->l('The overrides are disabled, you must enable them to use this module')) : '';
	}
	public function install()
	{
		if (!parent::install()
			|| !Configuration::updateValue('witm_config', '')
			|| !Configuration::updateValue('witm_css_js', 1)
			|| !Configuration::updateValue('witm_h_m', 1)
			|| !Configuration::updateValue('witm_fo', 1)
			|| !$this->registerHook('header'))
			return false;
		return true;
	}
	public function uninstall()
	{
		if (!parent::uninstall()
			|| !Configuration::deleteByName('witm_config')
			|| !Configuration::deleteByName('witm_css_js')
			|| !Configuration::deleteByName('witm_h_m')
			|| !Configuration::deleteByName('witm_fo')
			)
			return false;
		return true;
	}
	public function hookHeader()
	{
		if (defined('_PS_ADMIN_DIR_') && (int)Configuration::get('witm_fo') == 1)
			return;
		$this->context->controller->addCSS($this->_path.'views/css/'.$this->name.'_'.(int)Configuration::get('witm_h_m').'.css');
		if (Configuration::get('witm_h_m') != 3)
			$this->context->controller->addJS($this->_path.'views/js/'.$this->name.'.js');
		if (Configuration::get('witm_h_m') == 4)
			$this->context->controller->addJS($this->_path.'views/js/'.$this->name.'_ctrl.js');
	}
	private function displayHelp()
	{
		$tw = Configuration::get('BLOCKSOCIAL_TWITTER');
		$top = (version_compare(_PS_VERSION_, '1.6', '<'))? '' : 'top: -4px;'; 
		$this->_html = '
		<p style="float:right"><a href="http://www.coeos.pro/9-modules-prestashop"><img src="'.$this->_path.'/views/img/coeos_logo.jpg"/></a></p>
		<h1><img src="'.$this->_path.'logo.png"/> '.$this->displayName.' (v. '.$this->version.')</h1>
		<h3>'.$this->description.'<br/><br/><br/>
		<div style="height:15px line-height:16px;"><span style="float:left"><a target="_blank"href="http://www.coeos.pro">'.$this->l('follow us for free updates and news on').' www.coeos.pro</a></span>
		<div id="fb-root"></div>
		<script>(function(d, s, id) {
		  var js, fjs = d.getElementsByTagName(s)[0];
		  if (d.getElementById(id)) return;
		  js = d.createElement(s); js.id = id;
		  js.src = "//connect.facebook.net/fr_FR/sdk.js#xfbml=1&version=v2.5&appId=1112831942094478";
		  fjs.parentNode.insertBefore(js, fjs);
		}(document, \'script\', \'facebook-jssdk\'));</script>
				<div class="fb-like" data-href="http://www.coeos.pro" data-layout="button" data-action="like" data-show-faces="false" data-share="true" style="'.$top.'margin-left:5px"></div>
				<a href="https://twitter.com/share" 
				class="twitter-share-button"{count} 
				data-url=false
				data-text="♥ #module #prestashop '.$this->displayName.' (www.coeos.pro)"
				data-via="'.((isset($tw) && $tw != 'http://www.twitter.com/prestashop')? $tw : 'https://twitter.com/coeos_pro').'" 
				data-related="coeos_pro" 
				data-hashtags="">
				Tweet</a>
		<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0],p=/^http:/.test(d.location)?\'http\':\'https\';if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=p+\'://platform.twitter.com/widgets.js\';fjs.parentNode.insertBefore(js,fjs);}}(document, \'script\', \'twitter-wjs\');</script>

		<a href="https://twitter.com/coeos_pro" class="twitter-follow-button" data-show-count="false">Follow @coeos_pro</a>
		<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0],p=/^http:/.test(d.location)?\'http\':\'https\';if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=p+\'://platform.twitter.com/widgets.js\';fjs.parentNode.insertBefore(js,fjs);}}(document, \'script\', \'twitter-wjs\');</script>
		</div></h3><br/>
		<p>MASSON Vincent<br/>
		<a href="http://www.coeos.pro/9-modules-prestashop">www.coeos.pro</a><br/>
		<a href="mailto:contact@coeos.pro">contact@coeos.pro</a></p>';
	}
	public function getContent()
	{
		$this->displayHelp();
		if (Tools::getValue('submitConfigWITM'))
		{
			if ($this->saveConfigWITM())
				$this->_html .= $this->displayConfirmation($this->l('The data has been added successfully'));
			else
				$this->_html .= $this->displayError($this->l('An error occured during saving'));
		}
		$this->displayForm();
		return $this->_html;
	}
	private function saveConfigWITM()
	{
		$ip = Tools::getValue('ip');
		$css_js = (int)Tools::getValue('witm_css_js', 0);
		$h_m = (int)Tools::getValue('witm_h_m', 1);
		$witm_fo = (int)Tools::getValue('witm_fo', 0);
		Configuration::updateValue('witm_config', $ip);
		Configuration::updateValue('witm_css_js', $css_js);
		Configuration::updateValue('witm_h_m', $h_m);
		Configuration::updateValue('witm_fo', $witm_fo);
		return true;
	}
	private function displayForm()
	{
		$this->_html .= '<br/>
		<fieldset>
			<legend><img src="'.$this->_path.'logo.png" alt="" title="" /> '.$this->l('Configuration').'</legend>
			<form id="witm_config" method="post" action="" enctype="multipart/form-data" name="monform">
				<label>'.$this->l('Adress IP').'</label>
					<div class="margin-form">
						<input type="text" size="50" name="ip" value="'.Configuration::get('witm_config').'"/>
							<button type="button" class="btn btn-default" onclick="addRemoteAddr();"><i class="icon-plus"></i> '.$this->l('Add my IP').'</button>	
					</div>
					<div class="margin-form">'.$this->l('use the comma "," to separate multiple IP address').' '.$this->l('and * for select all IP address').'</div>
				<div class="clear"></div>
				
				<label>'.$this->l('Front office only').'</label>
					<div class="margin-form">
						<input type="checkbox" name="witm_fo" value="1" '.(((int)Configuration::get('witm_fo') == 1)? 'checked="checked"': '').'/>
						'.$this->l('If this box is not checked, the module will be active in the back office, and display will make it difficult to use of the BO.').'
					</div>
				<div class="clear"></div>
				
				<label>'.$this->l('open blocks H-M').'</label>
					<div class="margin-form">
						<select name="witm_h_m">
						<option value="1" '.(((int)Configuration::get('witm_h_m') == 1)? ' selected="selected"' : '').'>'.$this->l('on clic').'</option>
						<option value="2" '.(((int)Configuration::get('witm_h_m') == 2)? ' selected="selected"' : '').'>'.$this->l('on hover').'</option>
						<option value="3" '.(((int)Configuration::get('witm_h_m') == 3)? ' selected="selected"' : '').'>'.$this->l('all the time').'</option>
						<option value="4" '.(((int)Configuration::get('witm_h_m') == 4)? ' selected="selected"' : '').'>'.$this->l('with the touch ²').'</option>
						</select>
					</div>
				<div class="clear"></div>
				
				<label>'.$this->l('CSS and JS').'</label>
					<div class="margin-form">
						<input type="checkbox" name="witm_css_js" value="1" '.(((int)Configuration::get('witm_css_js') == 1)? 'checked="checked"': '').'/> '.$this->l('Displays the url of the CSS and JS file for each module').'
					</div>
				<div class="clear"></div>
				
				
				<div class="margin-form">
					<input type="submit" class="button" name="submitConfigWITM" value="'.$this->l('Save').'"/>
				</div>
				<script type="text/javascript">
					function addRemoteAddr()
					{
						var length = $(\'input[name=ip]\').attr(\'value\').length;
						if (length > 0)
							$(\'input[name=ip]\').attr(\'value\',$(\'input[name=ip]\').attr(\'value\') +\','.Tools::getRemoteAddr().'\');
						else
							$(\'input[name=ip]\').attr(\'value\',\''.Tools::getRemoteAddr().'\');
					}
				</script>		
			</form>
		</fieldset>';
	}
}